#!/bin/sh
#
# /etc/rc.d/rc.S:  System initialization script.

PATH=/sbin:/usr/sbin:/bin:/usr/bin

. /etc/rc.conf
. /etc/rc.d/functions
# anything more serious than KERN_WARNING goes to the console
/bin/dmesg -n 3

# Test to see if the root partition is read-only, like it ought to be.
READWRITE=no

stat_busy "Test, czy partycja / jest tylko do odczytu."
touch test_file 2>/dev/null
if [ $? = 0 ]; then
    READWRITE=yes
    rm -f test_file
else
    READWRITE=no;  
fi
stat_done


status "Aktywacja partycji wymiany" /sbin/swapon -a
# See if a forced filesystem check was requested at shutdown:

if [ -r /.forcefsck ]; then
  FORCEFSCK="-f"
fi

# Check the root filesystem:
if [ ! $READWRITE = yes ]; then
#  if [ ! -r /etc/fastboot ]; then
    stat_busy "Sprawdzanie podstawowego systemu plikow:"
	/sbin/fsck $FORCEFSCK -C -a -T /
	RETVAL=$?
    stat_done
#    stat_done
 # fi
  # An error code of 2 or higher will require a reboot.
  if [ $RETVAL -ge 2 ]; then
    # An error code equal to or greater than 4 means that some errors
    # could not be corrected.  This requires manual attention, so we
    # offer a chance to try to fix the problem in single-user mode:
    if [ $RETVAL -ge 4 ]; then
      stat_fail
      echo
      echo
      echo "***********************************************************"
      echo "*** Wykryto przy sprawdzaniu glownego systemu plikow.   ***"
      echo "*** teraz mozesz sie zalogowac do systemu w trybie      ***"
      echo "*** pojedynczego uzytkownika, zeby rozwiazac problem.   ***"
      echo "***                                                     ***"
      echo "*** Jesli uzywasz ext2 uruchomienie                     ***"
      echo "*** 'e2fsck -v -y </dev/hd**> moze pomoc.               ***"
      echo "***********************************************************"
      echo
      echo "Jesli opuscisz konsole, system sie zrestartuje."
      echo
      PS1="(Naprawa systemu plikow) \#"; export PS1
      sulogin
    else # With an error code of 2 or 3, reboot the machine automatically:
      echo
      echo
      echo "***********************************"
      echo "*** System plikow zmieniony.    ***"
      echo "*** Nastapi restart systemu.    ***"
      echo "***********************************"
      echo
    fi
    stat_done
    stat_busy "Odlaczenie systemow plikow."
    umount -a -r
    mount -n -o remount,ro /
    stat_done
    status "Restart systemu."
    sleep 2
    reboot -f
  fi

  # Remount the root filesystem in read-write mode
  status "Przelaczanie partycji / w tryb do odczytu i zapisu."
  /bin/mount -w -v -n -o remount / > /dev/null
  if [ $? -gt 0 ] ; then
    stat_fail
    echo
    echo "Przelaczenie partycji w trybie do odczytu i zapisu nieudane!  To wyglada"
    echo "na przyczyne powaznych problemow."
    echo 
    echo "Jesli uzywassz systemu UMSDOS, **MUSISZ** podlaczyc glowna partycje"
    echo "w trybie do odczytu i zapisu!  musisz byc pewny ze system plikow zostal podlaczony "
    echo "do zapisu i odczytu z  flaga 'rw' w Loadlin:"
    echo
    echo "loadlin vmlinuz root=/dev/hda1 rw   (zmien /dev/hda1 zgodnie z twoim ukladem)"
    echo
    echo "Normalne dyskietki startowe moga  byc podlaczane komenda rdev:"
    echo
    echo "rdev -R /dev/fd0 0"
    echo
    echo "Mozesz takze wejsc do systemu uzywajac dyskietki startowejz komenda"
    echo "w LILO:  (zmien glowna partycje tak jak potrzebujesz)"
    echo 
    echo "LILO: mount root=/dev/hda1 rw"
    echo
    echo "Nacisnij ENTER, zeby kontynuowac. Nastapi restart i uzyj jednej z powyzszych metod"
    echo -n "zeby rozwiazac problemy z komputerem. " 
    read junk; 
  fi
fi # Done checking root filesystem

# Any /etc/mtab that exists here is old, so we delete it to start over:
/bin/rm -f /etc/mtab*
# Remounting the / partition will initialize the new /etc/mtab:
/bin/mount -w -o remount / 2>/dev/null

# Initialize the Logical Volume Manager.
# This won't start unless /etc/lvmtab is found, which is created by /sbin/vgscan.
# Therefore, to use LVM you must run /sbin/vgscan yourself the first time.
if [ -r /etc/lvmtab ]; then
  # Mount /proc early (it's needed for vgscan):
  /bin/mount -a -t proc
  # Scan for new volume groups:
  /sbin/vgscan
  if [ $? = 0 ]; then
    # Make volume groups available to the kernel:
    /sbin/vgchange -ay
  fi
fi

# Check all the non-root filesystems:
#if [ ! -r /etc/fastboot ]; then
  stat_busy "Sprawdzanie pozostalych systemow plikow:"
  /sbin/fsck $FORCEFSCK -C -R -A -T -a
  stat_done
#fi

# mount non-root file systems in fstab (but not NFS or SMB 
# because TCP/IP is not yet configured):
/bin/mount -a -v -t nonfs,nosmbfs > /dev/null

# Clean up some temporary files:
( cd /var/log/setup/tmp && rm -rf * )
/bin/rm -f /var/run/utmp /var/run/*pid /etc/nologin /var/run/lpd* \
  /var/run/ppp* /etc/dhcpc/dhcpcd-*.pid /var/run/daemons/* /var/run/iptables \
  /var/run/$CONNECTION /var/lib/clamav/clamd.sock 2> /dev/null

echo "forcefsck" > /.forcefsck
# Create a fresh utmp file:
cat /dev/null > /var/run/utmp

# echo "NND Router" > /etc/motd

# Configure ISA Plug-and-Play devices:
if [ -r /etc/isapnp.conf ]; then
  if [ -x /sbin/isapnp ]; then
    /sbin/isapnp /etc/isapnp.conf
  fi
fi
#Ladowanie polskiej klawiatury i fontu

stat_busy "Uruchamianie polskiej klawiatury i fontu"

/bin/loadkeys /usr/share/kbd/keymaps/$KEYMAP 2>/dev/null
	
if [ "$CONSOLEFONT" != "" ]; then
/usr/bin/setfont /usr/share/kbd/consolefonts/$CONSOLEFONT 2>/dev/null
fi
stat_done


# Set the system time from the hardware clock using hwclock --hctosys.
stat_busy "Konfiguracja zegara systemowego"
if [ "$HARDWARECLOCK" = "UTC" ]; then
	/sbin/hwclock --utc --hctosys
else
	/sbin/hwclock --localtime --hctosys
fi
if [ ! -f /var/lib/hwclock/adjtime ]; then
	echo "0.0 0 0.0" > /var/lib/hwclock/adjtime
fi
if [ "$TIMEZONE" != "" ]; then
	/bin/ln -sf /usr/share/zoneinfo/$TIMEZONE /etc/localtime
fi
stat_done

#Load modules from the MODULES array defined in rc.conf
if [ -x /etc/rc.d/rc.modules -a -r /proc/modules ]; then
    . /etc/rc.d/rc.modules
fi


# Run serial port setup script:
# (CAREFUL! This can make some systems hang if the rc.serial script isn't
# set up correctly. If this happens, you may have to edit the file from a
# boot disk)
#
# . /etc/rc.d/rc.serial

# Carry an entropy pool between reboots to improve randomness.
# Load and then save 512 bytes, which is the size of the entropy pool.

if [ -f /etc/random-seed ]; then
	stat_busy "Inicjalizacja generatora liczb losowych"
	/bin/cat /etc/random-seed >/dev/urandom
	stat_done
fi

dd if=/dev/urandom of=/etc/random-seed count=1 bs=512 2> /dev/null

