.TH makepkg 8 "3 sierpnia 2004" "makepkg #VERSION#" ""
.SH NAME
make_nnd_pkg \- narzdzie budujce pakiety
.SH SYNOPSIS
\fBmake_nnd_pkg [opcje]\fP
.SH DESCRIPTION
\fBmake_nnd_pkg\fP suy do budowania pakietw. Potrzebny jest tylko odpowiednio
wyposaony system, wget oraz skrypty budujce. Przewag budowy pakietw opartej
o skrypty jest to, e tak naprawd prac wykonuje si tylko raz. Kiedy jest ju
gotowy skrypt budujcy dla pakietu, wystarczy wykona makepkg i reszta zrobi
si sama: zostan pobrane i zweryfikowane rda, sprawdzone zalenoci,
skonfigurowane ustawienia, skompilowane pliki rdowe, pliki wynikowe
zainstalowane do katalug tymczasowego, dokonane poprawki, wygenerowane
informacje o pakiecie i w kocu cao zostanie spakowana do archiwum, z
ktrego uytek bdzie potrafi zrobi \fBpacman\fP.

\fBmakeworld\fP moe by uyty do przebudowania caych grup pakietw lub te
caego drzewa rde. Wicej informacji po wydaniu polecenia \fBmakeworld
--help\fP. \fBmakeworld\fP w chwili obecnej nie jest kompatybilny i nie dziaa 
z NND.

.SH PROCES BUDOWY (czy te Jak Zbudowa Wasny Pakiet)
Zaczynamy od osobnego katalogu (tzn. nie jest on uywany do niczego ninnego jak
tylko do budowania tego pakietu). Skrypt budujcy powinien nosi nazw PKGBUILD
i przypomina przykad znajdujcy si niej.

\fBUWAGA:\fP wzr pliku PKGBUILD powinien znajdowa si w katalogu /var/abs.
Wystarczy skopiowa plik /var/abs/PKGBUILD.proto do nowego katalogu (o takiej
samej nazwie jak nazwa budowanego pakietu), zmieni jego nazw na PKGBUILD 
i wyedytowa wszystkie zmienne.

\fBUWAGA2:\fP w celu zachowania zgodnoci z makepkg pochodzcym z dystrybucji
Arch Linux make_nnd_pkg jest linkiem symbolicznym do pliku /usr/bin/makepkg.
W zalenoci od tego pod jak nazw zostanie uruchomiony pakiety bd budowane
zgodnie z zaoeniami NND (make_nnd_pkg) lub Arch Linuksa (makepkg). 

\fBUWAGA3:\fP w trybie NND nie wszystkie opcje wywoania zostay w peni
przetestowane. Niektre mog nie dziaa.

.TP
.TP
.SH Przykadowy PKGBUILD:
.RS
.nf
pkgname=modutils
pkgver=2.4.25
pkgrel=1
pkgdesc="Utilities for inserting and removing modules from the linux kernel"
url="http://www.kernel.org"
backup=(etc/modules.conf)
makedepends=('bash' 'mawk')
depends=('glibc' 'zlib')
source=(ftp://ftp.kernel.org/pub/linux/utils/kernel/$pkgname/v2.4/$pkgname-$pkgver.tar.bz2 \\
        modules.conf)
md5sums=('2c0cca3ef6330a187c6ef4fe41ecaa4d' \\
        '35175bee593a7cc7d6205584a94d8625')

build() {
  cd $startdir/src/$pkgname-$pkgver
  ./configure --prefix=/usr --enable-insmod-static
  make || return 1
  make prefix=$startdir/pkg/usr install
  mv $startdir/pkg/usr/sbin $startdir/pkg
  mkdir -p $startdir/pkg/etc
  cp ../modules.conf $startdir/pkg/etc
}
.fi
.RE

Jak wida, skrypt jest stosunkowo prosty. Pierwsze trzy linie definiuj nazw
i wersj pakietu. Na ich podstawie okrelana jest te docelowa nazwa pakietu,
ktra ma posta \fI$pkgname-$pkgver-$pkgrel.pkg.tar.gz\fP. Czwarta linia to
krtki opis pakietu. Te cztery linie powinny by obecne w kadym skrypcie
PKGBUILD.

Linia \fIbackup=\fP definiuje pliki, ktre powinny by traktowane w specjalny
sposb przy usuwaniu lub aktualizacji pakietu. Wicej szczegw w sekcji
\fBOBSUGA PLIKW KONFIGURACYJNYCH\fP na stronie manuala \fIpacmana\fP.

Linie sidma i sma okrelaj zalenoci pakietu. Tablica \fIdepends\fP
zawiera zalenoci czasu uruchamiania, za \fImakedepends\fP - czasu budowania.
Aby uruchomi pakiet, spenione musz by zalenoci z \fIdepends\fP. Aby
zbudowa pakiet, \fBwszystkie\fP zalenoci musz by spenione. makepkg
sprawdzi je przed budowaniem pakietu.

Tablica \fIsource\fP mwi, ktre pliki powinny by pobrane/rozpakowane przed
rozpoczciem kompilacji. Tablica \fImd5sums\fP dostarcza sumy kontrolne dla
kadego z tych plikw. Uwane s one do sprawdzenia poprawnoci plikw
rdowych.

Kiedy ju PKGBUILD bdzie gotowy, mona uruchomi \fImakepkg\fP z katalogu,
w ktrym znajduje si skrypt. makepkg sprawdzi zalenoci i poszuka wymaganych
plikw rdowych. Jeeli jakiego bdzie brakowa, sprbuje go pobra, pod
warunkiem, e w tablicy \fIsource\fP znajduje si dokadnu adres URL.

rda s wtedy rozpakowywane do katalogu ./src i wywoywana jest funkcja
\fIbuild\fP. Tam powinny odby si konfiguracja, kompilacja i instalacja
pakietu, jak rwnie wszelkie dostrajanie.

Po kompilacji funkcja \fIbuild\fP musi zainstalowa pliki w specjalnym
katalogu, do ktrego mona si odnie przez \fB$startdir\pkg\fP. Najczciej
osiga si to jednym z dwch sposobw:
.RS
.nf

make DESTDIR=$startdir/pkg install

lub

make prefix=$startdir/pkg/usr install

.fi
.RE
Naley zauway, e cz "/usr" powinna wystpi przy uyciu zmiennej
"prefix", ale nie przy zmiennej "DESTDIR". Zaleca si uywa wariantu ze
zmienn "DESTDIR", lecz nie wszystkie pliki Makefile j obsuguj. Zmiennej
"prefix" naley uywa tylko wtedy, gdy nie mona uy zmiennej "DESTDIR".

Kiedy ju pliki zostan zainstalowane we wspomnianym katalogu, \fImakepkg\fP
usunie niektre katalogi jak /usr/doc i /usr/info. Nastpnie skompilowany 
i zainstalowany w $startdir/pkg program zostanie podzielony - manuale znajd
si w katalogu $startdir/man_pkg, a pliki nagwkowe w katalogu $startdir/dev_pkg. 
W nastpnej kolejnoci zostan zrzucone symbole debugowania z bibliotek 
i binariw oraz wygenerowana informacja o pakiecie. 
Tu przed wygenerowaniem informacji o pakiecie uytkownik ma moliwo 
uruchomienia MC i 'rcznej' korekty pooenia plikw w pakietach. W kocu 
wszystko zostanie skompresowane do plikw *.pkg.tar.gz i zapisane w katalogu, 
w ktrym zosta uruchomiony \fBmakepkg\fP.

W tym momencie w biecym katalogu powinny znajdowa si pakiety, w postaci
plikw o nazwach wg wzoru: nazwa_pakietu-wersja-numer_wydanie.pkg.tar.gz
(nazwa_pakietu-[man|devel]-wersja-numer_wydania.pkg.tar.gz).
.SH Skrypty instalacji/aktualizacji/usuwania
pacman ma moliwo przechowywania i wykonywania skryptw specyficznych
dla pakietu, kiedy wykonuje instalacj, usuwanie lub aktualizacj. Pozwala
to na automatyczn konfiguracj pakietu po instalacji oraz dokonanie
czynnoci odwrotnej przed jego usuniciem.

Moment wykonania skryptu rni si w zalenoci od instalacji:
.TP
.B pre_install
skrypt jest wykonywany tu przed rozpakowaniem plikw.

.TP
.B post_install
skrypt jest wykonywany tu po rozpakowaniu plikw.

.TP
.B pre_upgrade
skrypt jest wykonywany tu przed rozpakowanie plikw.

.TP
.B post_upgrade
skrypt jest wykonywany tu po rozpakowaniu plikw.

.TP
.B pre_remove
skrypt jest wykonywany tu przed usuniciem plikw.

.TP
.B post_remove
skrypt jest wykonywany tu po usuniciu plikw.

.RE
Aby skorzysta z tej funkcjonalnoci, wystarczy utworzy plik (np.
pkgname.install) i umieci go w tym samym katalogu co skrypt PKGBUILD.
Nastpnie naley uy dyrektywy \fIinstall\fP:
.RS
.nf
install=pkgname.install
.fi
.RE

Plik ze skryptami nie musi by wymieniony z tablicy \fIsource\fP.

.TP
.TP
.SH Pliki ze skryptami musz by zgodne z nastpujcym formatem:
.RS
.nf
# arg 1:  the new package version
pre_install() {
  #
  #  do pre-install stuff here
  #
  /bin/true
}

# arg 1:  the new package version
post_install() {
  #
  #  do post-install stuff here
  #
  /bin/true
}

# arg 1:  the new package version
# arg 2:  the old package version
pre_upgrade() {
  #
  #  do pre-upgrade stuff here
  #
  /bin/true
}

# arg 1:  the new package version
# arg 2:  the old package version
post_upgrade() {
  #
  #  do post-upgrade stuff here
  #
  /bin/true
}

# arg 1:  the old package version
pre_remove() {
  #
  #  do pre-remove stuff here
  #
  /bin/true
}

# arg 1:  the old package version
post_remove() {
  #
  #  do post-remove stuff here
  #
  /bin/true
}

op=$1
shift
$op $*
.fi
.RE

Powyszy szablon jest take dostpny w drzewie ABS (/var/abs/install.proto).

.SH Dyrektywy skryptu PKGBUILD
.TP
.B pkgname
Nazwa pakietu, powinna by zgodna z konwencj nazewnictwa w systemach Unix,
gdy zostanie uyta w nazwie pliku.

.TP
.B pkgver
Wersja programu, dokadnie taka, jak okreli autor (np. 2.7.1).

.TP
.B pkgrel
Numer wydania, specyficzny dla pakietw Arch Linux.

.TP
.B pkgdesc
Krtki opis pakietu i jego funkcjonalnoci.

.TP
.B force
Uywane w celu wymuszenia aktualizacji pakietu przez opcj \fB--sysupgrade\fP,
nawet jeli jest to starsza wersja.

.TP
.B url
Opcjonalny URL zwizany z pakietowanym programem. Zazwyczaj jest to strona
domowa projektu.

.TP
.B license
Okrela rodzaj licencji (np. "GPL", "BSD", "NON-FREE"). (\fBUwaga:\fP ta
dyrektywa wci jest w fazie rozwojowej i moe ulec zmianie w przyszoci.)

.TP
.B install
Okrela specjalny skrypt instalacyjny, ktry bdzie doczony do pakietu.
Plik ten powinien znajdowa si w tym samym katalogu, co skrypt PKGBUILD.
Zostanie automatycznie skopiowany do pakietu przez makepkg. Nie musi by
uwzgldniony w tablicy \fIsource\fP. Przykad: install=modutils.install

.TP
.B source \fI(tablica)\fP
Dyrektywa \fIsource\fP jest tablic plikw rdowych wymaganych do zbudowania
pakietu. Pliki musz znajdowa si w tym samym katalogu, co skrypt PKGBUILD,
chyba e podano ich adresy URL. Wtedy, jeeli plik nie istnieje te w katalogu
/var/cache/pacman/src, jest pobierany przy uyciu programu wget.

.TP
.B md5sums \fI(tablica)\fP
Jeeli ta dyrektywa jest obecna, powinna zawiera sumy kontrolne MD5 dla
kadego pliku rdowego, wymienionego w tablicy \fIsource\fP (w odpowiadajcej
kolejnoci). makepkg uyje tych informacji, aby zweryfikowa poprawno
plikw rdowych. W celu atwego wygenerowania sum kontrolnych, mona uy
polecenia \fBmakepkg -g >> PKGBUILD\fP oraz wyedytowa skrypt PKGBUILD i
przenie sum w odpowiednie miejsce.

.TP
.B groups \fI(tablica)\fP
Jest to tablica symbolicznych nazw reprezentujcych grupy pakietw,
pozwalajcych na instalacj wielu pakietw za pomoc jednego celu. Na przykad,
mona zainstalowa wszystkie pakiety wchodzce w skad KDE, instalujc tylko
grup 'kde'.

.TP
.B backup \fI(tablica)\fP 
Tablica nazw plikw (bez rozpoczynajcego znaku slash), ktrych kopie zapasowe
maj by utworzone przy usuwaniu pakietu z systemu. Wicej informacji w sekcji
\fBOBSUGA PLIKW KONFIGURACYJNYCH\fP na stronie manuala \fIpacmana\fP.

.TP
.B depends \fI(tablica)\fP 
Tablica pakietw, od ktrych zaley budowanie i uruchamianie tego pakietu.
Pakiety z tej listy powinny by otoczone apostrofami i zawiera przynajmniej
nazw pakietu. Mona te poda wymagan wersje w postaci \fBnazwa<>wersja\fP,
gdzie <> jest jednym z nastpujcych operatorw porwnania: \fB>=\fP (wiksza lub
rwna), \fB<=\fP (mniejsza lub rwna) lub \fB=\fP (rwna). Przykady uycia
dyrektywy \fIdepends\fP mona znale w powyszym przykadowym pliku PKGBUILD.

.TP
.B makedepends \fI(tablica)\fP
Tablica pakietw, od ktrych zaley budowanie pakietu (tj. nie s wymagane
do uruchomienia). Lista ma taki sam format jak lista \fIdepends\fP.

.TP
.B conflicts \fI(tablica)\fP 
Tablica pakietw, ktre pozostaj w konflikcie z tym pakietem (tzn. nie mog
jednoczenie by zainstalowane w systemie). Lista ma taki sam format jak lista
\fIdepends\fP z tym, e nie mona podawa wersji, tylko nazwy pakietw.

.TP
.B provides \fI(tablica)\fP 
Tablica "wirtualnych funkcjonalnoci", ktre ten pakiet dostarcza. Dyrektywa ta
pozwala definiowa pakiet jako zaleno uywajc innej nazwy, ni nazwa
pakietu. Na przykad, pakiety kernel-scsi i kernel-ide dostarczaj
funkcjonalno 'kernel', co pozwala na okrelenie zalenoci jako 'kernel',
zamiast "kernel-scsi OR kernel-ide OR ...".

.TP
.B replaces \fI(tablica)\fP 
Jest to tablica pakietw, ktre ten pakiet powinien zastpi. Moe by to uyte
do obsugi przemianowanych/poczonych pakietw. Na przykad, jeeli pakiet
kernel zostanie przemianowany na kernel-ide, wtedy polecenie 'pacman -Syu' nie
wybierze nowego pakietu jako aktualizacji, poniewa nazwy s inne. Dyrektywa
\fIreplaces\fP pozwala to obej.

.TP
.B nosplit \fIyes|no\fP 
Zmienna okrelajca czy podczas budowy pakiet ma zosta podzielony automatycznie
na pakiety *-devel i *-man (zawierajce odpowiednio pliki nagwkowe i strony
manuali). Ta zmienna jest ignorowana w trybie Arch Linux (makepkg)

.TP
.B pre_pacinkg \fIyes|no\fP 
Zmienna okrelajca czy uruchomi dodatkow funkcj pre_pack(). Funkcja ta \fImusi\fP 
by obecna w pliku PKGBUILD. Gwnyum zastosowaniem tej funkcji jest wykonywanie 
operacji na plikach, ktre nie istniej w czasie wykonywania funkcji build().
Szczeglnie przydatna jest do edycji plikw PKGBUILD dla automatycznie budowanych 
pakietw *-devel i *-man. Funkcja pre_pack() jest wykonywana po automatycznym
podziale na 'pakiet' 'pakiet-devel' i 'pakiet-man' i bezporednio przed
operacj budowy (kompresja i generowanie plikw .PKGINFO i .FILELIST) pakietw. 
Funkcja pre_pack() powinna by uywana zamiast 'rcznej' korekty pooenia 
plikw w pakiecie. Ta zmienna jest ignorowana w trybie Arch Linux (makepkg) i
funkcja pre_pack() nie jest wykonywana w tym trybie.


.SH OPCJE MAKEPKG
.B "\-a, \-\-auto"
Ta opcja powoduje, e pakiet jest budowany automatycznie, bez moliwoci
poprawienia pooenia plikw przez osob budujc pakiet. Bez tej opcji
make_nnd_pkg przed operacj budowy pakietu (kompresja i generowanie plikw
.PKGINFO i .FILELIST) daje uytkownikowi moliwo uruchomienia MC i skorygowania
pooenia plikw w pakietach. W trybie Arch Linux ta opcja bdzie ignorowana.  
.TP
.B "\-b, \-\-builddeps"
Powoduje budowanie brakujcych zalenoci ze rde. Kiedy makepkg wykryje
niespenion zaleno czasu budowania lub czasu uruchamiania, poszuka dla niej
pliku PKGBUILD w drzewie $ABSROOT (definiowanym w pliku /etc/makepkg.conf).
Jeeli znajdzie, uruchomi kolejn instancj makepkg, aby zbudowa i
zainstalowa brakujc zaleno. Potomna instancja makepkg zostanie wywoana
z opcjami \fB-b\fP oraz \fB-i\fP.
.TP
.B "\-c, \-\-clean"
Usuwa zbdne pliki/katalogi po udanym budowaniu.
.TP
.B "\-C, \-\-cleancache"
Usuwa wszystkie pliki rdowe z pamici podrcznej, aby zwolni miejsce na
dysku.
.TP
.B "\-d, \-\-nodeps"
Nie sprawdza zalenoci, pozwala na pominicie/zignorowanie wszelkich
wymaganych zalenoci. Istnieje dua szansa, e opcja ta popsuje proces
budowania, jeeli adna z zalenoci nie bdzie speniona.
.TP
.B "\-f, \-\-force"
\fBmakepkg\fP nie zbuduje pakietu, jeeli plik
\fIpkgname-pkgver-pkgrel.pkg.tar.gz\fP istnieje ju w katalogu. Opcja
\fB--force\fP zmienia to zachowanie.
.TP
.B "\-g, \-\-genmd5"
Pobiera wszystkie pliki rdowe (jeeli jest to konieczne) i uywa narzdzia
\fImd5sum\fP, aby wygenerowa sumy kontrolne dla kadego z nich. Mona
przekierowa wyjcie do pliku PKGBUILD, aby zweryfikowa rda (makepkg -g >>
PKGBUILD).
.TP
.B "\-h, \-\-help"
Wywietla skadni i opcje linii polece.
.TP
.B "\-i, \-\-install"
Instaluje/uaktualnia pakiet po udanym zbudowaniu.
.TP
.B "\-j <jobs>"
Ustawia zmienn MAKEFLAGS="-j<jobs>" przed rozpoczciem budowy. Mona dziki
temu nadpisa ustawienie MAKEFLAGS z pliku /etc/makepkg.conf.
.TP
.B "\-m, \-\-nocolor"
Wycza kolorowanie komunikatw.
.TP
.B "\-n, \-\-nostrip"
Zapobiega zrzucaniu symboli debugowania z binariw i bibliotek.
.TP
.B "\-o, \-\-nobuild"
Jedynie pobiera i rozpakowuje pliki, nie buduje pakietu.
.TP
.B "\-p <buildscript>"
Korzysta z pliku \fI<buildscript>\fP zamiast z domylnego (\fI(PKGBUILD\fP).
.TP
.B "\-r, \-\-rmdeps"
Po udanym zbudowaniu pakietu, usuwa wszystkie zalenoci zainstalowane przez
makepkg automatycznie (kiedy zostaa uyta opcja \fB-b\fP lub \fB-s\fP).
.TP
.B "\-s, \-\-syncdeps"
Instaluje brakujce zalenoci uywajc pacmana. Kiedy makepkg wykryje
niespenione zalenoci czasu budowania lub czasu uruchamiania, uruchomi
pacmana, aby ten sprbowa je rozwiza. Jeeli mu si uda, pobierze i
zainstaluje brakujce pakiety.
.TP
.B "\-w <destdir>"
Zapisuje wynikowe pakiety w katalogu \fI<destdir>\fP zamiast w katalogu
biecym.

.SH KONFIGURACJA
Opcje konfiguracyjne przechowywane s w pliku \fI/etc/makepkg.conf\fP. Plik
ten jest traktowany jako skrypt Basha, wic mona w nim eksportowa dowolne
specjalne flagi kompilatora. Jest to pomocne przy budowaniu dla rnych
architektur, czy te z rnymi ustawieniami optymailizacji.

\fBUWAGA:\fP Nie ma gwarancji, e wszystkie pliki Makefile bd uywa
eksportowanych zmiennych. Niektre z tych plikw s uomne...
.SH ZOBACZ TAKE
\fBpacman\fP jest menederem pakietw, ktry uywa pakietw zbudowanych przy
uyciu makepkg.

.SH AUTOR
.nf
Judd Vinet <jvinet@zeroflux.org>
.fi
.SH TUMACZENIE
.nf
Jarosaw wierczyski <swiergot@juvepoland.com>
.fi
.SH WERSJA DLA NND
.nf
Micha M. Lechaski <michal@doriath.homeip.net>
.fi
